class User < ActiveRecord::Base
  has_one :author
  
  # Include default devise modules. Others available are:
  # :token_authenticatable, :encryptable, :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :token_authenticatable, :validatable#, :confirmable

  # Setup accessible (or protected) attributes for your model
  attr_accessible :id, :name, :password, :password_confirmation, :remember_me , :email

  before_create do |r|
    r.build_author :name => 'no name'
  end
  
  def create_token
    self.ensure_authentication_token
    self.save
  end
  
  def delete_token
    self.authentication_token = nil
    self.save
  end
  
end
