﻿/*
 * pettanR common.js
 *   version 0.4.9
 * 
 * author: itozyun
 */

/*
 * http://pettanr.sourceforge.jp/test/type.html
 */
	var Type = {
		isObject : function(v) {
			return typeof v === 'object';
		},
		isFunction : function(v) {
			return typeof v === 'function';
		},
		isArray : function(v) {
			return Object.prototype.toString.call(v) === "[object Array]";
		},
		isBoolean : function(v) {
			return typeof v === 'boolean';
		},
		isString : function(v) {
			return typeof v === 'string';
		},
		isNumber : function(v) {
			return typeof v === 'number';
		},
		isHTMLElement : ( 'HTMLElement' in window ?
			function(v){
				return v instanceof HTMLElement
			} :
			function(v) {
				if( Type.isObject(v) === false ){
					return false;
				}
				var r;
				if(v && v.nodeType === 1){
					try{
						r = v.cloneNode(false);
					} catch(n) {
						return false;
					}
					if(r === v) return false;
					try{
						r.nodeType = 9;
						return r.nodeType === 1;
					} catch(n) {}
					return true;
				}
				return false;
			}
		),
		/*
		isElementCollection : function(v) {
			return (Object.prototype.toString.call(v) === "[object HTMLCollection]");
		},
		*/
		isNull : function(v) {
			return v === null;
		},
		isUndefined : function(v) {
			return typeof v === 'undefined';
		}
	};


var pettanr = ( function(){
	var	FUNCTION_ARRAY = [],
		URL = document.location.href.split( '#')[ 0],
		IS_LOCAL = URL.indexOf( 'file:') === 0,
		URL_PARAMS = ( function(){
			var search = document.location.search,
				l = search.length;
		    if( 1 < l){
		        var	query = search.substring( 1),
					params = query.split( '&'),
					ret = {}, elm, name, v;
		        while( params.length > 0){
		            elm = params.shift().split( '=');
					name = decodeURIComponent( elm[ 0]);
					if( elm.length === 2){
						v = decodeURIComponent( elm[ 1]);
						if( '' + parseFloat( v) === v) v = parseFloat( v);
						if( '' + parseInt( v) === '0' + v) v = parseInt( v);
						if( v === 'true') v = true;
						if( v === 'false') v = false;
						if( v === 'null') v = null;
						if( v === 'undefined') v = undefined;
			            ret[ name] = v;
					} else
					if( elm.length === 1){
						ret[ name] = true;
					}
		        }
		        return ret;
		    }
		    return {};
		})(),
		IS_DEBUG = typeof URL_PARAMS.debug === 'boolean' ? URL_PARAMS.debug : IS_LOCAL === true,
		jqWindow , jqDocument , jqBody;
	return {
		version: '0.4.9',
		init: function(){
			jqWindow = $( window);
			jqDocument = $( document);
			jqBody = $( document.body);
			
			var l = FUNCTION_ARRAY.length,
				_fn;
			for( var i=0; i<l; i++){
				_fn = FUNCTION_ARRAY[ i];
				_fn.init && _fn.init( _fn === pettanr.view ? FUNCTION_ARRAY : undefined);
			}
			
			delete pettanr.init;
		},
		fn: function( _fn){
			FUNCTION_ARRAY.push( _fn);
			pettanr.init === undefined && _fn.init && _fn.init();
		},
		jqWindow: function(){
			return jqWindow;
		},
		jqDocument: function(){
			return jqDocument;
		},
		jqBody: function(){
			return jqBody;
		},
		URL_PARAMS: URL_PARAMS,
		ROOT_PATH: ( function(){
			// script と html の ドメインが一致
			var _h1 = document.getElementsByTagName( 'h1')[ 0],
				_a = _h1.getElementsByTagName( 'a')[ 0],
				_root = _a.href.split( '\/'),
				_current = document.location.href.split( '\/'),
				ret = '.\/';
			for( var i=0, l=_current.length - _root.length; i<l; ++i){
				ret = '.' + ret;
			}
			return ret;
			// script と html の ドメインが不一致
		})(),
		LOCAL: IS_LOCAL,
		DEBUG: IS_DEBUG,
		LINE_FEED_CODE_TEXTAREA: ( function(){
			var text = document.createElement('textarea');
			text.value = '\n';
			return text.value;
		})(),
		LINE_FEED_CODE_PRE: ( function(){
			var pre = document.createElement('pre');
			pre.appendChild( document.createTextNode('\n'));
			return pre.firstChild.data;
		})(),
		IS_IFRAME: !!window.parent
	}
})();

/*
 * pettanr.util
 * 
 *   extend( baseInstance, extend)
 *   cleanCommnetNode()
 *   cleanElement()
 *   getElementSize( _elm)
 *   getImageSize()
 *   getAbsolutePath()
 *   getGrobalObjectName()
 * 
 */
pettanr.util = ( function(){
	var ELM_SIZE_GETTER = ( function(){
			var ret = document.createElement( 'DIV'),
				style = ret.style;
			ret.id = 'elmSizeGetter';
			style.position = 'absolute';
			style.left = '0px';
			style.top = '-9999px';
			style.visibility = 'hidden';
			document.body.appendChild( ret);
			return ret;
		})(),
		IMG_SIZE_GETTER = ( function(){
			var ret = ELM_SIZE_GETTER.cloneNode( true);
			ret.id = 'imgSizeGetter';
			document.body.appendChild( ret);
			return ret;
		})(),
		CLEAN_TARGET_ELEMENT = 'script,style,object,applet,embed,iframe,frame,base,bgsound,frameset,listing'.split( ',');
	
	/* clean comment node */
	cleanCommnetNode();
	
	/* clean noscript */
	var nodeNoscript = document.getElementsByTagName( 'noscript'),
		noscript;
	for(var i=0; i<nodeNoscript.length; ++i){
		noscript = nodeNoscript[i];
		noscript.parentNode && noscript.parentNode.removeChild( noscript);
	}
	nodeNoscript = noscript = null;
	
	function cleanCommnetNode( _targetElm){
		search( _targetElm || document.body );
		
		function search( _elm){
			if( !_elm) return;
			if( _elm.nodeType === 8){
				_elm.parentNode.removeChild( _elm);
				return;
			}
			var i, l, _children = _elm.childNodes, _array = [];
			if( _children && typeof _children.length === 'number'){
				// liveNode　> array
				for( i=0, l=_children.length; i<l; ++i){
					_array.push( _children[ i ] );
				}
				while( _array.length !== 0 ){
					search( _array.shift());
				}
			}
		}
	}
	return {
		extend: function( baseInstance, extend){
			for( var key in extend){
				if( typeof baseInstance[ key] === 'undefined'){
					baseInstance[ key] = extend[ key];
				} else
				if( typeof baseInstance[ key] === typeof extend[ key]){
					baseInstance[ key] = extend[ key];
				} else {
					alert( 'extend error');
				}
			}
			return baseInstance;
		},	
		cleanCommnetNode: cleanCommnetNode,
		cleanElement: function( _targetElm){
			var _nodes, _elm, _array, j, m;
			for( var i=0, l=CLEAN_TARGET_ELEMENT.length; i<l; ++i){
				_nodes = _targetElm.getElementsByTagName( CLEAN_TARGET_ELEMENT[ i]);
				_array = [];
				for( j=0, m = _nodes.length; j<m; ++j){
					_array.push( _nodes[ j]);
				}
				for( j=0, m = _array.length; j<m; ++j){
					_elm = _nodes[ j];
					_elm.parentNode && _elm.parentNode.removeChild( _elm);
				}
			}
			cleanCommnetNode( _targetElm);
			if( pettanr.ua.isIE === false) return;
			_nodes = _targetElm.all || _targetElm.getElementsByName( '*');
			for( i=0, l = _nodes.length; i<l; ++i){
				_elm = _nodes[ i];
				_elm.style.filter = '';
				_elm.style.behavior = '';
			}
		},
		getElementSize: function( _elm){
			if( !_elm){
				return {
					width:	0,
					height:	0
				}
			}
			var	parentElm = _elm.parentNode,
				prevElm = _elm.previousSibling,
				nextElm = _elm.nextSibling,
				displayNone = _elm.style.display === 'none';
			if( displayNone === true) _elm.style.display = '';
			ELM_SIZE_GETTER.appendChild( _elm);
			var ret = {
				width:		_elm.offsetWidth,
				height:		_elm.offsetHeight
			}
			if( displayNone === true) _elm.style.display = 'none';
			if( nextElm){
				parentElm.insertBefore( _elm, nextElm);
			} else		
			if( prevElm && prevElm.nextSibling){
				parentElm.insertBefore( _elm, prevElm.nextSibling);
			} else {
				parentElm && parentElm.appendChild( _elm);
			}			
			return ret;
		},
		getImageSize: function( img){
			var	parentElm = img.parentNode,
				prevElm = img.previousSibling,
				nextElm = img.nextSibling,
				displayNone = img.style.display === 'none';
			if( displayNone === true) img.style.display = '';
			IMG_SIZE_GETTER.appendChild( img);
			
			var size = getActualDimension( img);
			
			IMG_SIZE_GETTER.removeChild( img);
			if( displayNone === true) img.style.display = 'none';
			if( nextElm){
				parentElm.insertBefore( img, nextElm);
			} else		
			if( prevElm && prevElm.nextSibling){
				parentElm.insertBefore( img, prevElm.nextSibling);
			} else {
				parentElm && parentElm.appendChild( img);
			}
			return size;
			
		/* LICENSE: MIT
		 * AUTHOR: uupaa.js@gmail.com
		 */
			function getActualDimension(image) {
				var run, mem, w, h, key = "actual";
			
			// for Firefox, Safari, Google Chrome
				if ("naturalWidth" in image) {
					return {
						width:	image.naturalWidth,
						height:	image.naturalHeight
					};
				}
			
				if ("src" in image) { // HTMLImageElement
					if (image[key] && image[key].src === image.src) {
						return image[key];
					}
					if (document.uniqueID) { // for IE
						run = image.runtimeStyle;
						mem = { w: run.width, h: run.height }; // keep runtimeStyle
						run.width  = "auto"; // override
						run.height = "auto";
						w = image.width;
						h = image.height;
						run.width  = mem.w; // restore
						run.height = mem.h;
					} else { // for Opera and Other
						mem = { w: image.width, h: image.height }; // keep current style
						image.removeAttribute("width");
						image.removeAttribute("height");
						w = image.width;
						h = image.height;
						image.width  = mem.w; // restore
						image.height = mem.h;
					}
					return image[key] = { width: w, height: h, src: image.src }; // bond
				}
				// HTMLCanvasElement
				return { width: image.width, height: image.height };
			}
		},
		loadImage: function( URLorELM, onLoad, onError, delay, timeout){
			delay = delay || 250;
			timeout = timeout || 5000;
			var type = typeof URLorELM,
				img, images, src, abstractPath;
			if( type === 'string'){
				src = URLorELM;
				// images = [];
			} else
			// http://d.hatena.ne.jp/hottolinkblog/20090228/1235823487
			if( type === 'object' && typeof URLorELM.hspace !== 'undefined' && typeof URLorELM.vspace !== 'undefined'){
				img = URLorELM;
				images = [ img];
				src = img.src;
			} else {
				return;
			}
			abstractPath = this.getAbsolutePath( src);
			
			loadImage( images, abstractPath, onLoadAsync, onErrorAsync, delay, timeout);
			
			function onLoadAsync( abspath, actualW, actualH){
				if( abstractPath !== abspath) return;
				var _g_onUpdateFunction = pettanr.util.createGlobalFunction( onLoad);
					_onTimeout = pettanr.util.createGlobalFunc( [
						'function(){',
							'window["', _g_onUpdateFunction, '"]( "', abspath, '", ', actualW, ',  ', actualH, ');',
							'window["', _g_onUpdateFunction, '"] = null;',
						'}'
					].join( ''));
				onLoad && setTimeout( window[ _onTimeout], 0);
				window[ _onTimeout] = null;
			}
			function onErrorAsync( abspath){
				if( abstractPath !== abspath) return;
				var _g_onUpdateFunction = pettanr.util.createGlobalFunction( onError);
					_onTimeout = pettanr.util.createGlobalFunc( [
						'function(){',
							'window["', _g_onUpdateFunction, '"]( "', abspath, '");',
							'window["', _g_onUpdateFunction, '"] = null;',
						'}'
					].join( ''));
				onError && setTimeout( window[ _onTimeout], 0);
				window[ _onTimeout] = null;
			}
			
		/*  LICENSE: MIT?
		 *  URL: http://d.hatena.ne.jp/uupaa/20080413/1208067631
		 *  AUTHOR: uupaa.js@gmail.com
		 * 
		 *  fixed for ie6-8 by pettanr
		 *   new Image -> document.createElement( 'img')
		 */
			function loadImage( images, abspath, onLoad, onError, delay, timeout) {
				images = images || document.images;
				var img,
					i = 0, l = images.length,
					tick = 0;
				for(; i < l; ++i) {
					img = images[i];
					if ( img.src === abspath && img.complete) {
						var size = pettanr.util.getImageSize( img);
						onLoad( abspath, size.width, size.height);
						return;
					}
				}
				img = document.createElement( 'img'); //var img = new Image(); ではieでimgのsizeが取れない、、、removeChildも失敗し、imgSizeGetterにimgが残る
				img.finish = false;
				img.onabort = img.onerror = function() {
					if (img.finish) { return; }
					img.finish = true;
					onError(abspath);
					img.onload = img.onabort = img.onerror = "";
				};
				img.onload  = function() {
					img.finish = true;
					if (window.opera && !img.complete) {
						onError(abspath);
						img.onload = img.onabort = img.onerror = "";
						return;
					}
					var size = pettanr.util.getImageSize( img);
					onLoad( abspath, size.width, size.height);
					img.onload = img.onabort = img.onerror = "";
					//img = void 0;
				};
				img.src = abspath;
				if (!img.finish && timeout) {
					setTimeout(function() {
						if (img.finish) { return; }
						if (img.complete) {
							img.finish = true;
							if (img.width) { return; }
							onError(abspath);
							img.onload = img.onabort = img.onerror = "";
							return;
						}
						if ((tick += delay) > timeout) {
							img.finish = true;
							onError(abspath);
							img.onload = img.onabort = img.onerror = "";
							return;
						}
						setTimeout(arguments.callee, delay);
					}, 0);
				}
			}
		},
		getAbsolutePath: function( path) {
			var e = document.createElement("div");
			e.innerHTML = '<a href=\"' + path + '\" />';
			return e.firstChild.href;
		},
		getAbsolutePosition: function( _elm){
			// Find the destination's position
			var	destx = _elm.offsetLeft,
				desty = _elm.offsetTop,
				thisNode = _elm,
				body = document.body;
			while (thisNode.offsetParent && thisNode.offsetParent !== body){
				thisNode = thisNode.offsetParent;
				destx += thisNode.offsetLeft;
				desty += thisNode.offsetTop;
			}
			return {
				x:	destx,
				y:	desty
			}
		},
		pullHtmlAsTemplete: function( IDorELM){
			if( typeof IDorELM === 'string'){
				IDorELM = document.getElementById( IDorELM);
			}
			if( !IDorELM) return;
			IDorELM.parentNode && IDorELM.parentNode.removeChild( IDorELM);
			if( IDorELM.id && IDorELM.id.indexOf( 'templete-') === 0){
				IDorELM.removeAttribute( 'id');
			}
			return IDorELM;
		},
		getElementsByClassName: function( _elm, _className, opt_tagName){
			var _all = !opt_tagName || opt_tagName === '*',
				_nodes = _all === true ? ( _elm.all || _elm.getElementsByTagName( '*')) : _elm.getElementsByTagName( opt_tagName),
				_node, _classes, ret = [];
			for( var i=0, l = _nodes.length; i<l; ++i){
				_node = _nodes[ i];
				_node.nodeType === 1 && this.hasClassName( _node, _className) === true && ret.push( _node);
			}
			return ret;
		},
		getChildIndex: function( _parent, _child){
			var _children = _parent.getElementsByTagName( _child.tagName),
				l = _children.length;
			for(var i=0; i<l; ++i){
				if( _children[ i] === _child) return i;
			}
			return -1;
		},
		hasClassName: function( _elm, _className){
			var _classes = ( _elm.className || '').split( ' ');
			for( var i=0, l=_classes.length; i<l; ++i){
				if( _classes[ i] === _className) return true;
			}
			return false;
		},
		removeAllChildren: function ( _elm){
			while( _elm.firstChild){
				remove( _elm.firstChild);
			}
			function remove( _node){
				while( _node.firstChild){
					remove( _node.firstChild);
				}
				_node.parentNode && _node.parentNode.removeChild( _node);
			}
		},
		getIndex: function( _array, _element){
			if( Array.prototype.indexof){
				pettanr.util.getIndex = function( _array, _element){
					return _array.indexof( _element);
				}
			} else {
				pettanr.util.getIndex = function( _array, _element){
					for( var i=0, l = _array.length; i<l; ++i){
						if( _array[ i] === _element) return i;
					}
					return -1;					
				}
			}
			return pettanr.util.getIndex( _array, _element);
		},
		/*
		 * 
		 */
		createGlobalFunction: function( _func) {
			var randomKey = null;
			while( true) {
				randomKey = '_glovalFunction_' + ( '' + Math.random()).replace( /\./,'');
				if( eval( 'typeof '+randomKey) === 'undefined') {
					break;
				}
			}
			window[ randomKey] = _func;
			return randomKey;
		},
		createGlobalFunc: function( func){
			var randomKey = null;
			while(true) {
				randomKey = 'hogeGlovalFunc_'+(''+Math.random()).replace(/\./,'');
				if(eval('typeof '+randomKey) == 'undefined') {
					break;
				}
			}
			eval(randomKey+'='+((typeof func=='string') ? func : func.toString()));
			return randomKey;
		},
		createGlobalVar: function( obj){
			var randomKey = null;
			while(true) {
				randomKey = 'hogeGlovalVar_'+(''+Math.random()).replace(/\./,'');
				if(eval('typeof '+randomKey+'') == 'undefined') {
					break;
				}
			}
			var globalObj = eval(randomKey+'={}');
			globalObj.value = obj;
			return randomKey;
		},
		createGlobalUniqueName: function(){
			var randomKey = null;
			while(true) {
				randomKey = '_uniqueName'+(''+Math.random()).replace(/\./,'');
				if( typeof window[randomKey] === 'undefined'){
					break;
				}
			}
			return randomKey;
		},
		createIframe: function( id, callback){
			var ua = pettanr.ua;
            var el = document.createElement( ua.isIE ? '<iframe name="' + id + '" frameborder="0" scrolling="no">' : 'iframe');

            if( ua.isIE){
				el.onreadystatechange = detect;
            } else {
            	// iron(chrome) の場合、append の前に onload を指定しないと onload が呼ばれない
            	el.onload = onLoad;
            	//setTimeout( asynkCallback, 0 );
			}

			document.body.appendChild( el);
            el.id = el.name = id;
            el.setAttribute( 'name', id);
            el.style.cssText = 'width:1px;height:1px;visibility:hidden;position:absolute;top:1px;left:1px;';
			// http://d.hatena.ne.jp/onozaty/20070830/p1
			// [JavaScript]IE6ではJavaScriptで動的に作成したiframeに対してsubmitできない(IE7は未確認) ->解決
			el.contentWindow.name = id;					
            
            window[id] = el;

            function detect(){
                if ( this.readyState === "complete") {
                    this.onreadystatechange = new Function();
                    this.onreadystatechange = null;
                    setTimeout( asynkCallback, 0 );
                }
            }
			function onLoad(){
				el.onload = null;
				setTimeout( asynkCallback, 0 );
			}
			function asynkCallback(){
				callback( el );
			}
		}
	}
})();

/*
 * pettanr.ua
 * 
 *   detect userAgent
 *   detect plug in
 */
pettanr.ua = ( function(){
	var ua = (function(){
			var acme = {};
			
			var n = navigator;
			var dua = n.userAgent;
			var dav = n.appVersion;
			var tv = parseFloat(dav);
			acme.isOpera = (dua.indexOf("Opera") >= 0) ? tv: undefined;
			acme.isKhtml = (dav.indexOf("Konqueror") >= 0) ? tv : undefined;
			acme.isWebKit = parseFloat(dua.split("WebKit/")[1]) || undefined;
			acme.isChrome = parseFloat(dua.split("Chrome/")[1]) || undefined;
			var index = Math.max(dav.indexOf("WebKit"), dav.indexOf("Safari"), 0);
			if(index && !acme.isChrome){
				acme.isSafari = parseFloat(dav.split("Version/")[1]);
				if(!acme.isSafari || parseFloat(dav.substr(index + 7)) <= 419.3){
					acme.isSafari = 2;
				}
			}
			if(document.all && !acme.isOpera){
				acme.isIE = parseFloat(dav.split("MSIE ")[1]) || undefined;
			}
			
			return acme;
		})(),
		isIE = navigator.userAgent.toLowerCase().indexOf( 'msie') !== -1,
		ieVersion = isIE === true ? parseInt( navigator.appVersion.toLowerCase().replace( /.*msie[ ]/, '').match( /^[0-9]+/)) : 0,
		ieRenderingVersion = ieVersion === 8 ? document.documentMode : ieVersion,
		isStanderdMode = document.compatMode === 'CSS1Compat',
		ActiveX = ( function(){
			if( isIE === false || ieVersion > 8) return false;
			var	b = document.body,
				c = b.className || '',
				x,
				ret = pettanr.URL_PARAMS.ActiveX,
				ns = 'pettanr-ActiveX-',
				enabled = 'enabled',
				disabled = 'disabled';
			if( ret !== true && ret !== false){
				if( pettanr.util.hasClassName( b, ns + enabled) === true) return true;
				if( pettanr.util.hasClassName( b, ns + disabled) === true) return false;
				x = document.createElement('div');
				b.appendChild(x);
				x.style.cssText = 'width:1px;height:1px;line-height:1px;filter:progid:DXImageTransform.Microsoft.Shadow()';
				ret = x.offsetHeight > 1;
				b.removeChild(x);
			}
			b.className += [ c !== '' ? ' ' : c, ns, ret === true ? enabled : disabled ].join( '');
			return ret;
		})(),
		VML = ( function(){
			if( ActiveX === false || isIE === false || ieVersion > 8) return false;
			var globalObjectName = pettanr.util.createGlobalUniqueName(),
				script,
				id = 'detectVML';
			document.write( [ '<!--[if gte vml 1]><script id="', id, '">window', '.', globalObjectName, '=1;<\/script><![endif]-->'].join( ''));
			if( window[globalObjectName] === 1){
				script = document.getElementById( id);
				script.parentNode.removeChild( script);
				window[globalObjectName] = null;
				return true;
			}
			return false;
		})(),
		isStandAloneMode = ( function(){
			if( isIE === false) return false;
			if( VML === true) return false;
			var globalObjectName = pettanr.util.createGlobalUniqueName(),
				script,
				id = 'detectStandAlone';
			document.write( [ '<!--[if IE ', Math.floor( ieVersion), ']><script id="', id, '">window', '.', globalObjectName, '=1;<\/script><![endif]-->'].join( ''));
			if( window[globalObjectName] === 1){
				script = document.getElementById( id);
				script.parentNode.removeChild( script);
				window[globalObjectName] = null;
				return false;
			}
			return true;
		})();
	return {
		IE:					ua.isIE,
		GECKO:				0,
		OPERA:				ua.isOpera,
		KHTML:				ua.isKhtml,
		WEBKIT:				ua.isWebKit,
		CHROME:				ua.isChrome,
		isIE:				isIE,
		ieVersion:			ieVersion,
		ieRenderingVersion:	ieRenderingVersion,
		isStanderdMode:		isStanderdMode,
		VENDER_PREFIX: ( function() {
			var ua = navigator.userAgent.toLowerCase();
			if ( ua.indexOf('opera') !== -1) {
				return 'O';
			} else if ( ua.indexOf('msie') !== -1) {
				return 'ms';
			} else if ( ua.indexOf('webkit') !== -1) {
				return 'webkit';
			} else if ( navigator.product === 'Gecko') {
				return 'Moz';
			}
			return '';
		})(),
		ACTIVEX: ActiveX,
		VML: VML,
		STANDALONE: isStandAloneMode,
		startVML: function(){
			delete this.startVML;
			if( pettanr.ua.VML !== true) return false;
			if (!document.namespaces["v"]) {
		        document.namespaces.add("v", "urn:schemas-microsoft-com:vml", "#default#VML");
		    }
		    document.createStyleSheet().cssText = "v\:shape,v\:image{behavior:url(#default#VML);display:block;};";
		}
	}
})();


pettanr.CONST = ( function(){
	var isLocal = pettanr.LOCAL === true || pettanr.URL_PARAMS.exjson === false,
		isLocalhost = document.location.href.indexOf( 'http:\/\/localhost:3000\/' ) === 0,
		PETTANR_ROOT_PATH = isLocalhost === true ? 'http:\/\/localhost:3000\/' : 'http:\/\/pettanr.heroku.com\/';
		
	return {
		PETTANR_ROOT_PATH:			PETTANR_ROOT_PATH,
		URL_ORIGINAL_PICTURES_JSON: ( isLocal === true ? 'json\/' : PETTANR_ROOT_PATH) + 'original_pictures.json',
		URL_RESOURCE_PICTURES_JSON: ( isLocal === true ? 'json\/' : PETTANR_ROOT_PATH) + 'resource_pictures.json',
		URL_COMICS_JSON:			( isLocal === true ? 'json\/' : PETTANR_ROOT_PATH) + 'comics.json',
		URL_PANELS_JSON:			( isLocal === true ? 'json\/' : PETTANR_ROOT_PATH) + 'panels.json',
		NS_PETTANR_COMIC:			'pettanr-comic',
		RESOURCE_PICTURE_PATH:		( isLocal === true ? pettanr.ROOT_PATH : PETTANR_ROOT_PATH) + 'resource_pictures\/',
		CREATE_COMIC_JS:			isLocal === true ? 'js\/create_new_comic.js' : PETTANR_ROOT_PATH + 'comics\/new.js',
		UPLOAD_PICTURE_JS:			isLocal === true ? 'js\/upload_picture.js' : PETTANR_ROOT_PATH + 'original_pictures\/new.js',
		JQUERY_URL:					isLocal === true ? 'javascripts\/jquery-1.6.2.min.js' : PETTANR_ROOT_PATH + 'assets\/jquery-162_min.js'
	}
})();

pettanr.view = ( function(){
	/* create iframe overlay for user console */
	var location = document.location.pathname,
		isWorkPage =	document.location.href.indexOf( 'http:\/\/localhost:3000\/' ) === 0 ||
						location.indexOf( pettanr.CONST.PETTANR_ROOT_PATH ) === 0 ||
						location.indexOf( '\/work.html') !== -1 ||
						location.indexOf( '\work.html') !== -1,
		deep =	location.indexOf( '\/diary\/') !== -1 ||
				location.indexOf( '\/test\/') !== -1 ||
				location.indexOf( '\/help\/') !== -1 ||
				location.indexOf( '\/sitemap\/') !== -1 ||
				location.indexOf( '\/wiki\/') !== -1,
		LoginUserNavi;
	
	if( isWorkPage === false){
		LoginUserNavi = ( function(){
			var _body = document.body,
				_root = document.getElementsByTagName( 'html' )[ 0 ],
				filter,
				iframe, visible = false;
			return {
				show: function(){
					document.location.href = [
							deep === true ? '../' : '',
							'work.html',
							typeof viewIndex === 'number' ? '?view=' + viewIndex : ''
						].join( '');
				},
				hide: function(){}
			}
		})();
	} else {
		LoginUserNavi = ( function(){
			return {
				show: function(){
					var i = pettanr.util.getChildIndex( this.parentNode, this );
					i !== -1 && pettanr.view.show( i );
					return false;
				},
				hide: function(){}
			}
		})();

		if( pettanr.IS_IFRAME === true){
			var _nodes = document.getElementsByTagName( 'a'),
				_a, _href;
			for(var i=0, l = _nodes.length; i<l; i++){
				_a = _nodes[ i];
				_href = _a.href.split('?')[0].split('#')[0];
				if( pettanr.util.getAbsolutePath( _href) !== location) _a.target = '_parent';
			}
		}
		
		if( pettanr.DEBUG === true){
			var elmDl = document.getElementById( 'useragent'),
				elmDt, elmDd,
				data = {
					pettanR:	pettanr.version,
					ua:			navigator.userAgent,
					platform:	navigator.platform,
					appVersion:	navigator.appVersion,
					appCodeName:navigator.appCodeName,
					appName:	navigator.appName,
					language:	navigator.browserLanguage || navigator.language,
					ActiveX:	pettanr.ua.ACTIVEX
				},
				ua = pettanr.ua;
			if( ua.IE){
				//data.ua = 'Internet Explorer';
				data.version = ua.IE;
				if( ua.ieVersion >= 8) data.RenderingVersion = ua.ieRenderingVersion;
				data.browserType = ua.STANDALONE === true ? 'Standalone' : 'bundle';
				if( ua.ieVersion < 9) {
					data.vml = ua.VML;
				} else {
					data.svg = ua.SVG;
				}
			}
			data.RenderingMode = ua.isStanderdMode === true ? 'Standerd' : 'Quirks';
			
			for( var key in data){
				elmDt = document.createElement( 'dt');
				elmDt.innerHTML = key;
				elmDd = document.createElement( 'dd');
				elmDd.innerHTML = '' + data[ key];
				if( !data[ key]) elmDd.style.color = 'red';
				elmDl.appendChild( elmDt);
				elmDl.appendChild( elmDd);
			}
		} else {
			var _debug = document.getElementById( 'debug');
			if( _debug){
				pettanr.util.removeAllChildren( _debug);
				_debug.parentNode.removeChild( _debug);
			}
		}
	}

	/* global-navi */
	var navi = document.getElementById('global-navi'),
		origin = document.createElement('a'),
		items = ( function(){
			var ret = ['Home', 'Comic list', 'Picture', 'Setting'];
			pettanr.DEBUG === true && ret.push( 'debug');
			return ret;
		})(),
		l = items.length,
		item;
	origin.href = '#';
	for(var i=0; i<l; ++i){
		item = origin.cloneNode( true);
		item.appendChild( document.createTextNode( items[ i]) );
		item.onclick = LoginUserNavi.show;
		navi.appendChild( item);
	}
	navi.style.width = ( ( item.offsetWidth || 80) * l) +'px';
	location = origin = item = null;
	
	/* debug info */
	// ua version, lang, os, plugin ( vml, svg), standerdmode, balloon, rimg

/*
 * window resize event, overlay と currentなviewに流す
 * view modeの保持
 * 	 editor, overlay, comic-viewer, image-explorer
 * fadeIn, faseOut
 */

	var jqWindow,
		funcArray,
		HOME_ID = 'entrance',
		VIEW_ID_ARRAY = [ HOME_ID, 'cabinet', 'gallery', 'backyard'],
		elmCurrent,
		currentView,
		currentID = ( function( _view){
			var _viewID;
			
			if( typeof _view === 'number' && _view < VIEW_ID_ARRAY.length){
				_viewID = VIEW_ID_ARRAY[ _view];
			} else
			if( typeof _view === 'string'){
				_viewID = _view;
			} else {
				_viewID = HOME_ID;
			}

			if( document.getElementById( _viewID)){
				return _viewID;
			}
			return HOME_ID;
		})( pettanr.URL_PARAMS.view);
	
	pettanr.DEBUG === true && VIEW_ID_ARRAY.push( 'debug');
	
	show();
	
	function onWindowResize(){
		var _fn,
			l = funcArray.length,
			w = jqWindow.width(),
			h = jqWindow.height();
		//for( var i=0; i<l; ++i){
		//	_fn = funcArray[ i];
		//	_fn.onWindowResize && _fn.onWindowResize( w, h);
		//}
		currentView && currentView.onWindowResize && currentView.onWindowResize( w, h);
		pettanr.overlay.currentID !== null && pettanr.overlay.onWindowResize( w, h);
	}
	function show(){
		if( isWorkPage === false) return;
		
		var _elm = document.getElementById( currentID);
		if( elmCurrent) elmCurrent.style.display = 'none';
		_elm.style.display = 'block';
		elmCurrent = _elm;
		
		var	nodesA = navi.getElementsByTagName( 'a') || [],
			l = nodesA.length,
			_a;
		for(var i=0; i<l; ++i){
			if( nodesA[ i]){
				nodesA[ i].className = VIEW_ID_ARRAY[ i] === currentID ? 'current' : '';
			}
		}
		
		if( !pettanr.view || pettanr.view.init !== undefined) return;
		currentView = pettanr[ currentID];
		if( !currentView) return;
		typeof currentView.onOpen === 'function' && currentView.onOpen();
		setTimeout( onWindowResize, 0);
	}
	
	var AbstractBasicPane = function(){
		this.UID = '', // element の ID と一致
		this.onOpen = function(){};
		this.onClose = function(){};
		this.onPaneResize = function( _w, _h){};
		this.MIN_WIDTH = 0;
		this.MIN_HEIGHT = 0;
	}
	
	return {
		init: function( _funcArray){
			funcArray = _funcArray;
			jqWindow = pettanr.jqWindow();
			jqWindow.resize( onWindowResize);
			
			currentView = currentView || pettanr[ currentID];
			currentView && typeof currentView.onOpen === 'function' && currentView.onOpen();
			
			setTimeout( onWindowResize, 100);
			
			delete pettanr.view.init;
		},
		show: function( _viewID){
			if( typeof _viewID === 'number' && _viewID < VIEW_ID_ARRAY.length){
				_viewID = VIEW_ID_ARRAY[ _viewID];
			} else
			if( typeof _viewID === 'string'){
				_viewID = _viewID;
			} else {
				_viewID = HOME_ID;
			}
			for( var key in pettanr.view){
				if( pettanr.view[ key] === _viewID){
					if( currentID !== _viewID && document.getElementById( _viewID)){
						this.currentID = currentID = _viewID;
						show();
					}
					return;
				}
			}
			alert( _viewID);
		},
		resisterAsBasicPane: function( _basicPane){
			if( pettanr.view.isBasicPaneInstance( _basicPane ) === true ) return;
			_basicPane.prototype = new AbstractBasicPane();
		},
		isBasicPaneInstance: function( _basicPane){
			return  _basicPane instanceof AbstractBasicPane;
		},
		currentID:	currentID,
		HOME:		HOME_ID,
		COMICS:		VIEW_ID_ARRAY[ 1],
		IMAGES:		VIEW_ID_ARRAY[ 2],
		SETTING:	VIEW_ID_ARRAY[ 3],
		DEBUG:		VIEW_ID_ARRAY[ 4],
		EDITOR:		'editor',
		OVERLAY:	'overlay'
	}
})();

pettanr.overlay = ( function(){
	var SHADOW_OPACITY = 0.5,
		jqConteiner, jqShadow, jqCloseButton,// jqBody, 
		currentOverlay = null,
		visible = false,
		windowW, windowH;

	function close(){
		currentOverlay && currentOverlay.onClose && currentOverlay.onClose();
		pettanr.overlay.hide();		
	}
	function asyncResize(){
		currentOverlay.onWindowResize( windowW, windowH);
	}
	function onCloseClick( e){
		close();
		e.preventDefault();
		return false;		
	}
	return {
		init: function(){
			//jqBody = pettanr.jqBody();
			jqConteiner = $( '#overlay-container');
			jqShadow = $( '#overlay-shadow');
			jqCloseButton = $( '#overlay-close-button').click( onCloseClick);
			
			pettanr.key.addKeyDownEvent( pettanr.view.OVERLAY, 27, false, false, close); // 27.esc
			
			delete pettanr.overlay.init;
		},
		show: function( _currentOverlay){
			if( visible === true && currentOverlay === _currentOverlay) return;
			jqConteiner.stop().css( {
				filter:		'',
				opacity:	''
			}).fadeIn();
			this.visible = visible = true;
			currentOverlay = _currentOverlay;
			this.currentID = _currentOverlay.ID;
			jqCloseButton.toggle( !!_currentOverlay.onClose);
		},
		hide: function(){
			currentOverlay = null;
			if( visible === false) return;
			jqConteiner.stop().css( {
				filter:		'',
				opacity:	''
			}).fadeOut();
			this.visible = visible = false;
			this.currentID = null;
		},
		visible: visible,
		currentID: null,
		onWindowResize: function( _windowW, _windowH){
			jqConteiner.css( { height:	_windowH});
			jqShadow.css( { height:	_windowH});
			windowW = _windowW;
			windowH = _windowH;
			// 先にeditorのcanvasを確定する。
			currentOverlay && currentOverlay.onWindowResize && setTimeout( asyncResize, 0);
		},
		resisterOverlay: function( _basicPane){
			pettanr.view.resisterAsBasicPane( _basicPane);
			// OverlayAPI
			return {
				show: function( _basicPane ){
					
				},
				hide: function( _basciPane ){
					
				},
				isCurrent: function( _basicPane ){
					
				}
			}
		},
		isOverlay: function( _basicPane ){
			
		}
	}
})();

/* ----------------------------------------
 * KEY
 * 
 *  - EDITABLE_TEXT_CONTROL
 * 
 *    .SHIFT_DOWN_EVENT:	'shiftDown',
 *    .SHIFT_UP_EVENT:		'shiftUp',
 *    .CTRL_DOWN_EVENT:		'ctrlDown',
 *    .CTRL_UP_EVENT:		'ctrlUp',
 *    .SPACE_DOWN_EVENT:	'spaceDown',
 *    .SPACE_UP_EVENT:		'spaceUp',
 *    .init:				function,
 *    .addKeyDownEvent:		function,
 *    .keyEventDispatcher:	function,
 * 
 * ショートカットキーの監視とテキスト入力(input, textarea)、チェックボックスを管理する。
 * キー入力はdocumentで受けて、テキスト編集中(input, textarea)はそちらにキーイベント流す。
 * 
 */
pettanr.key = ( function(){
	var log,
		jqWindow,
		keyOperationChatcher,
		KEYEVENT_ARRAY = [],
		shiftEnabled = false,
		ctrlEnabled = false;
	
	function keyHit( e){
		log.html( [ e.keyCode, e.shiftKey, e.ctrlKey, e.altKey, e.type].join( ','));
		//keyOperationChatcher.val( '');
		var cancel = false,
			callback = e.type,
			key = e.keyCode,
			overlayEnabled = pettanr.overlay.visible === true,
			currentViewID = overlayEnabled === true ? pettanr.overlay.currentID : pettanr.view.currentID;
		if( callback === 'keypress') callback = 'keydown';
		if( pettanr.form.keyEventRellay( e) === false){
			var shift = e.shiftKey,
				ctrl = e.ctrlKey,
				l = KEYEVENT_ARRAY.length,
				d;
			if( key === 16 || e.shiftKey === true){
				shiftEnabled = callback !== 'keyup';
			}
			if( key === 17 || e.ctrlKey === true){
				ctrlEnabled = callback !== 'keyup';
			}

			for( var i=0; i<l; i++){
				d = KEYEVENT_ARRAY[ i];
				if( (
						d.viewID === currentViewID ||
							( overlayEnabled === true && d.viewID === pettanr.view.OVERLAY)
					) &&
					d.keyCode === key &&
					( d.shift === undefined || d.shift === shift) &&
					( d.ctrl === undefined || d.ctrl === ctrl)
				){
					( function( func, e){
						func && setTimeout( function(){
							func( e);
							func = e = null;
						}, 0);
					})( d[callback], e);
					cancel = true;
				}
			}
		}
		if( cancel === true || key === 18 || key === 9 || key === 27 || e.altKey === true){ // 13.enter 18.esc 9.tab 27.esc   || ( key === 13 && overlayEnabled === false)
			e.preventDefault();
	        e.keyCode = 0;
	        e.cancelBubble = true;
	        e.returnValue = false;
			return false;
		}
	}
	
	var keyPress = pettanr.ua.isIE === true && pettanr.ua.ieRenderingVersion < 8 ? ( function( e){
			var key = e.keyCode;
			if( key === 13 || key === 27){
				keyHit( e);
				return false;
			}
	}) : null;
	
	return {
		init: function(){
			log = $( '#key-event-log').html( 'ready');

			jqWindow = pettanr.jqWindow().focus();
			keyOperationChatcher = pettanr.jqDocument()
				.keydown( keyHit)
				.keyup( keyHit)
				.mouseenter( function(){
					jqWindow.focus();
				});
			keyPress && keyOperationChatcher.keypress( keyPress);

			delete pettanr.key.init;
		},
		addKeyDownEvent: function( _viewID, _keyCode, _shift, _ctrl, _callbackFunction){
			KEYEVENT_ARRAY.push( {
				viewID:			_viewID,
				keyCode:		_keyCode,
				shift:			_shift,
				ctrl:			_ctrl,
				keydown:		_callbackFunction
			});
		},
		addKeyUpdateEvent: function( _viewID, _keyCode, _shift, _ctrl, _callbackFunction){
			KEYEVENT_ARRAY.push( {
				viewID:		_viewID,
				keyCode:	_keyCode,
				shift:		_shift,
				ctrl:		_ctrl,
				keydown:	_callbackFunction,
				keyup:		_callbackFunction
			});
		},
		addCursorEvent: function( _viewID, _shift, _ctrl, _callbackFunction){
			
		},
		keyEventDispatcher: function(){
			return keyOperationChatcher;
		},
		shiftEnabled: function(){
			return shiftEnabled;
		},
		ctrlEnabled: function(){
			return ctrlEnabled;
		}
	}
})();

/*
 * pettanr.form
 * 
 * keyEventRellay
 *  form -> overlay -> view
 * 
 */
pettanr.form = ( function(){
	var	FORM_GROUP_TABLE = {},
		currentID = null,
		currentItem = null,
		ELM_A_ORIGIN = ( function(){
			var ret = document.createElement( 'a');
			ret.href = '#';
			return ret;
		})(),
		ELM_INPUT_TEXT = ( function(){
			var ret = document.createElement( 'input');
			ret.type = 'text';
			return ret;
		})();
		
	var InputTextClass = function( WRAPPER_ELM, ON_UPDATE_FUNCTION, GROUP_ID, validater){
		validater = typeof validater === 'function' ? validater : null;
		
		var elmValue = pettanr.util.getElementsByClassName( WRAPPER_ELM, 'editable-value')[ 0],
			value,
			index = GROUP_ID ? FORM_GROUP_TABLE[ GROUP_ID].length : -1,
			instance,
			focus = false,
			visible = true,
			enabled = true,
			elmA = ELM_A_ORIGIN.cloneNode( true);
		
		if( elmValue === undefined){
			alert( 'error!');
		}
		value = elmValue.innerHTML;
		elmValue.innerHTML = '';
		elmValue.className += ' editable-text';
		
		elmA.innerHTML = value;
		elmValue.appendChild( elmA);
		WRAPPER_ELM.onclick = onClick;
		
		function onClick( e){
			focus = true;
			start( instance);
			elmA.style.display = 'none';
			elmValue.appendChild( ELM_INPUT_TEXT);
			ELM_INPUT_TEXT.value = value;
			ELM_INPUT_TEXT.focus();
			ELM_INPUT_TEXT.select();
			e && e.preventDefault();
			return false;
		}
		
		return {
			init: function(){
				instance = this;
				delete this.init;
			},
			value: function( _value){
				if( _value !== undefined){
					elmA.innerHTML = _value;
					value = _value;
					
					if( focus === true){
						ELM_INPUT_TEXT.value = value;
					}
				}
				currentItem === instance && this.finish();
				return value;
			},
			start: function(){
				onClick();
			},
			finish: function( keep){
				var _newValue = ELM_INPUT_TEXT.value,
					_validated = validater !== null ? '' + validater( _newValue) : _newValue;
				_newValue = keep !== true ? _validated : value;

				elmValue.removeChild( ELM_INPUT_TEXT);
				
				elmA.innerHTML = _newValue;
				elmA.style.display = 'block';
				
				ON_UPDATE_FUNCTION && _newValue !== value && ON_UPDATE_FUNCTION( _newValue, value);
				finish( instance);
				value = _newValue;
				focus = false;
			},
			enabled: function(){
				return enabled;
			},
			visible: function( _visible){
				if( _visible === true){
					WRAPPER_ELM.style.display = '';
					visible = true;
				} else
				if( _visible === false){
					WRAPPER_ELM.style.display = 'none';
					visible = false;
				}
				return visible;
			},
			index : index,
			groupID: GROUP_ID
		}
	}

	var FileInputClass = function( WRAPPER_ELM, ON_UPDATE_FUNCTION, GROUP_ID, validater, elmFileInput){
		validater = typeof validater === 'function' ? validater : null;
		
		var elmFilePath = pettanr.util.getElementsByClassName( WRAPPER_ELM, 'file-path')[ 0],
			value,
			index = GROUP_ID ? FORM_GROUP_TABLE[ GROUP_ID].length : -1,
			instance,
			focus = false,
			visible = true,
			enabled = true,
			elmFileInput = WRAPPER_ELM.getElementsByTagName('input')[0] || elmFileInput || document.createElement( 'input');
		elmFileInput.type = 'file';
		elmFileInput.style.visivility = 'hidden';

		WRAPPER_ELM.onclick = onClick;
		elmFileInput.onchenge = onChange;
		
		function onClick( e){
			focus = true;
			start( instance);
			elmFileInput.click();
			return false;
		}
		
		function onChange(){
			elmFilePath.innerHTML = elmFileInput.value;
		}
		return {
			init: function(){
				instance = this;
				delete this.init;
			},
			start: function(){
				onClick();
			},
			finish: function( keep){
				focus = false;
			},
			enabled: function(){
				return enabled;
			},
			visible: function( _visible){
				if( _visible === true){
					WRAPPER_ELM.style.display = '';
					visible = true;
				} else
				if( _visible === false){
					WRAPPER_ELM.style.display = 'none';
					visible = false;
				}
				return visible;
			},
			index : index,
			groupID: GROUP_ID
		}
	}


	function start( _currentItem){
		currentItem !== _currentItem && currentItem && currentItem.finish();
		currentItem = _currentItem;
	}
	function finish( _currentItem){
		if( currentItem !== _currentItem) return;
		currentItem = null;
	}

	function tabShift( _groupID, _index, _way){
		var GROUP_ARRAY = FORM_GROUP_TABLE[ _groupID] || [],
			l = GROUP_ARRAY.length,
			i = _index +_way;
		if( l < 2) return;
		while( i !== _index){
			i = i < 0 ?
				l -1 :
				i === l ? 0 : i; // 0 < i < l
			if( GROUP_ARRAY[ i].enabled() === true && GROUP_ARRAY[ i].visible() === true) break;
			i += _way;
		}
		if( i === _index) return;
		setTimeout( GROUP_ARRAY[ i].start, 0);
	}

	return {
		init: function(){},
		focus: function(){
			return currentItem !== null; 
		},
		keyEventRellay: function( e){
			if( e.type === 'keyup') return false;
			if( currentItem === null) return false;
			
			var keyCode = e.keyCode;
			if( keyCode === 13 || keyCode === 27 || keyCode === 9 || keyCode === 18 || e.altKey === true){ // 13.return 27.esc 9.tab 18.alt
				var _groupID = currentItem.groupID,
					_index = currentItem.index;
				currentItem.finish( keyCode === 27);
				keyCode === 9 && _groupID && tabShift( _groupID, _index, e.shiftKey === true ? -1 : 1);
				keyCode === 13 && _groupID && tabShift( _groupID, _index, 1);
			}
			return true;
		},
		createInputText: function( _elm, _onUpdate, _groupID, _validater){
			if( typeof _groupID === 'string' && !FORM_GROUP_TABLE[ _groupID]){
				FORM_GROUP_TABLE[ _groupID] = [];
			}
			var ret = new InputTextClass( _elm, _onUpdate, _groupID, _validater);
			ret.init();
			_groupID && FORM_GROUP_TABLE[ _groupID].push( ret);
			return ret;
		},
		createFileInput: function( _elm, _onUpdate, _groupID, _validater, _elmFileInput){
			if( typeof _groupID === 'string' && !FORM_GROUP_TABLE[ _groupID]){
				FORM_GROUP_TABLE[ _groupID] = [];
			}
			var ret = FileInputClass( _elm, _onUpdate, _groupID, _validater, _elmFileInput);
			ret.init();
			_groupID && FORM_GROUP_TABLE[ _groupID].push( ret);
			return ret;
		},
		createCheckBox: function(){
			
		},
		createRadio: function(){
			
		},
		createButton: function(){
			
		},
		createListBox: function(){
			
		}
	}
})();


/* ----------------------------------------
 * Vector Support
 * 
 *              __________
 *             /          \
 *            /            \
 *            |,startX,Y    |
 * tailX,Y - <              |
 *            |'endX,Y      |
 *            \            /
 * 	           \__________/
 * 
 * SVG
 * -----------------------
 * ie9, other modern browser
 * 
 * XML
 * -----------------------
 * ie5.5-8
 * 
 * 内部の角度計算は radian で統一したい。
 * 当初 vectorEnabled = true で一度書いてみる。
 * 駄目なら、代替のイメージのsrcの用意もここで担当。
 * 閲覧と編集両方で使う。
 * 
 */
pettanr.balloon = ( function() {
	var MIN_BALLOON_WIDTH = 30,
		MIN_BALLOON_HEIGHT = 30,
		TAIL_WIDTH = 6,
		TAIL_HEIGHT = 10,
		STROKE_WIDTH = 1.2,
		PADDING_TOP = TAIL_HEIGHT,
		PADDING_LEFT = TAIL_HEIGHT,
		ACCURACY = 1, // 有効少数桁	
		IS_VML = pettanr.ua.isIE === true && pettanr.ua.ieVersion < 9,
		ELM_BALLOON_ORIGIN = ( function(){
			var ret;
			try {
				if( IS_VML === true){
					ret = document.createElement( 'DIV');
					var shape = document.createElement( 'v:shape');
					shape.coordorigin = "0,0";
					shape.strokecolor = "black";
					shape.strokeweight = STROKE_WIDTH;
					shape.fillcolor = "white";
					ret.appendChild( shape);
				} else {
					var kSVGNS = 'http://www.w3.org/2000/svg';
					ret = document.createElementNS( kSVGNS, 'svg');
					var path = document.createElementNS( kSVGNS, 'path');
					path.setAttribute( 'fill', "white");
					path.setAttribute( 'stroke', "black");
					path.setAttribute( 'strokeWidth', STROKE_WIDTH);
					ret.appendChild( path);
				}
				return ret;	
			} catch( e){
				return null;
			}
		})(),
		NUM_BALLOON_IMAGE = 24,
		vectorEnabled = ELM_BALLOON_ORIGIN !== null && pettanr.URL_PARAMS.vector !== false;
	if( IS_VML === true && pettanr.ua.VML === false) vectorEnabled = false;

	var XBROWSER_BALLOON_CLASS = function( w, h, a){
		var balloonElm = vectorEnabled === true ? ELM_BALLOON_ORIGIN.cloneNode( true) : document.createElement( 'img'), // pettanr.imageに変更
			path = balloonElm.getElementsByTagName( 'path')[ 0],
			shape = balloonElm.getElementsByTagName( 'shape')[ 0],
			cos = Math.cos, sin = Math.sin,
			abs = Math.abs, pow = Math.pow,
			round = Math.round,
			floor = Math.floor,
			TARGET = TAIL_WIDTH * TAIL_WIDTH,
			DEG_TO_RAD = Math.PI / 180,
			l = ',';
		
		draw( a, w, h);
		
		function draw( _a, _w, _h){
			a = _a !== undefined ? _a : a;
			w = _w !== undefined ? _w -PADDING_TOP *2 : w;
			h = _h !== undefined ? _h -PADDING_LEFT *2 : h;

			if( vectorEnabled === false){
				balloonElm.setAttribute( 'src', balloonUrlBuilder( a));
				return;
			}
			
			var rx = w /2,
				ry = h /2,
				tailRad = a * DEG_TO_RAD,
				tailX = rx +( rx +TAIL_HEIGHT) * cos( tailRad),
				tailY = ry +( ry +TAIL_HEIGHT) * sin( tailRad),
				startX, startY, endX, endY;
		/*
		 * tailの太さをTAIL_WIDTHに一致させるため、角度を絞りつつ計算
		 */
			var startRad, endRad,
				_startX, _startY, _endX, _endY,
				tailDeg = 0, d;
			
			for( var i = 45; i > 0.01; i /= 2){
				d = ( tailDeg +i) /2;
				startRad = ( a +d) * DEG_TO_RAD;
				endRad = ( a -d) * DEG_TO_RAD;
				
				_startX = rx +cos( startRad) *rx;
				_startY = ry +sin( startRad) *ry;
				_endX = rx +cos( endRad) *rx;
				_endY = ry +sin( endRad) *ry;	//円弧上のY位置＝円中心Y＋sin(角度×PI÷180)×円半径
					
				if( pow( ( _startX -_endX), 2) + pow( ( _startY -_endY), 2) < TARGET){
					tailDeg += i;
					startX = _startX;
					startY = _startY;
					endX = _endX;
					endY = _endY;						
				}
			}

		/*
		 * 
		 */			
			if( IS_VML === true){
				var _tailX = tailX *10,
					_tailY = tailY *10,
					__startX = startX *10,
					__startY = startY *10,
					__endX = endX *10,
					__endY = endY *10,
					__w = w *10,
					__h = h *10;
				
				shape.style.width = w +'px';
				shape.style.height = h +'px';
				shape.coordsize = [ __w, __h].join( l);
				shape.path = [
					' ar ', 0, l, 0, l, __w, l, __h, l,
					round( __endX), l, round( __endY), l,
					round( __startX), l, round( __startY),
					' l ', round( _tailX), l, round( _tailY),
					' x e'
				].join( '');

				balloonElm.style.marginTop =  _tailY < 0 ? floor( ( 60 +_tailY) /10) : 10;
				balloonElm.style.marginLeft = _tailX < 0 ? floor( ( 60 +_tailX) /10) : 10;
			} else {
				balloonElm.setAttribute( 'width', w +PADDING_LEFT *2);
				balloonElm.setAttribute( 'height', h +PADDING_TOP *2);
				path.setAttribute( 'd', [
					'M', cround( tailX + PADDING_LEFT), l, cround( tailY +PADDING_TOP),
					'L', cround( startX +PADDING_LEFT), l, cround( startY +PADDING_TOP),
					'A', rx, l, ry,
					'0 1 1',			// flag
					cround( endX +PADDING_LEFT), l, cround( endY +PADDING_TOP),
					'z'
				].join( ' '));
			}
			function cround( v, r){
				r = r || ACCURACY;
				return round( v *pow( 10.0, r)) /pow( 10.0, r);
			}
		}
		
		function balloonUrlBuilder( _a){
			var d = 360 /NUM_BALLOON_IMAGE;
			_a += 90 +d /2;
			return [ 'system_pictures\/_w', _a < 360 -d /2 ? floor( _a /d) : 0, '.gif'].join( '');
		}
		return {
			elm: balloonElm,
			resize: draw,
			angle: function( _a){
				_a !== undefined && _a !== a &&
					vectorEnabled === false ? balloonUrlBuilder( _a) : draw( _a);
				return a;
			},
			type: function( _type){
				//draw( _a);
			},
			getURL: function(){
				return balloonUrlBuilder( a);
			},
			destroy: function(){
				balloonElm.parentNode && balloonElm.parentNode.removeChild( balloonElm);
				balloonElm = null;
				delete this.destroy;
			}
		}
	};
	
	IS_VML === false && vectorEnabled === true && ( function(){
		var detect = XBROWSER_BALLOON_CLASS.apply( {}, [ 100, 100, 0]),
			size = pettanr.util.getElementSize( detect.elm);
		vectorEnabled = size.width !== 0 && size.height !== 0;
		detect.destroy();
		detect = size = null;
	})();

	return {
	    createBalloon: function( _w, _h, _a){
	    	return XBROWSER_BALLOON_CLASS.apply( {}, [ _w, _h, _a]);
	    },
		TYPE_NONE:				0,
		TYPE_SPEACH_BALLOON:	1,
		TYPE_THINKING:			2,
		TYPE_BOM:				3,
		TYPE_BLACK_BOX:			4,
		TYPE_BLUE_BOX:			5
	}
})();

/* ----------------------------------------
 *  pettanr.image
 *  
 *   xBackendな画像反転、画像描画機能。
 *   
 *   画像の反転
 *     - css3
 *     - ActiveX (ie)
 *     - VML (ie)
 *     - canvas ??
 *     - flash(lite)
 *     - silverlight
 *     - pettan server
 *   
 *   png画像の表示(アルファpngをサポートしないie6以下のため)
 *     - ActiveX
 *     - VML
 *     - flash(lite)
 *     - silverlight
 *     
 *     -moz-transform:scale( -1, -1);
 */
pettanr.image = ( function(){
	var REG_PNG = /\.png?/i,
		IS_CSS3 = 0,
		IS_VML = 1,
		IS_ACTIVEX = 2,
		IS_CANVAS = 3,
		IS_FLASH = 4,
		IS_SILVERLIGHT = 5,
		IS_SERVER = 6,
		IS_ACTIVEX_SERVER = 7,
		BACKEND = ( function(){
			if( pettanr.DEBUG === true && pettanr.URL_PARAMS.rimg){
				var rimg = pettanr.URL_PARAMS.rimg.toLowerCase();
				if( rimg === 'css3') return IS_CSS3;
				if( rimg === 'activex') return IS_ACTIVEX;
				if( rimg === 'vml') return IS_VML;
			}
			if( pettanr.ua.isIE === false || pettanr.ua.ieVersion >= 9) return IS_CSS3; // 不十分！
			if( pettanr.ua.VML === true) return IS_VML;
			if( pettanr.ua.ACTIVEX === true) return IS_ACTIVEX;
			if( pettanr.FLASH === true) return IS_FLASH;
			if( pettanr.SILVERLIGHT === true) return IS_SILVERLIGHT;
			return IS_SERVER;
		})(),
		BACKEND_WHEN_PNG = ( function(){
			if( pettanr.ua.isIE === false || pettanr.ua.ieVersion > 6) return BACKEND;
			if( pettanr.ua.VML === true) return IS_VML;
			if( pettanr.FLASH === true) return IS_FLASH;
			if( pettanr.SILVERLIGHT === true) return IS_SILVERLIGHT;
			if( pettanr.ua.ACTIVEX === true) return IS_ACTIVEX_SERVER;
			return IS_SERVER;
		})(),
		ReversibleImageClass,
		ReversibleImageClassWithPingfix;
	
	var XBackendReversibleImageClass = ( function(){
		var CLASS_NAME = 'reversible-image-container',
			CLASS_NAME_LOADING = CLASS_NAME + ' loading',
			CLASS_NAME_ERROR = CLASS_NAME +' error',
			RETRY_DELAY = 5000;
			NUM_RETRY = 3;
		
		var css3Image = function( url, w, h, onLoadCallback){
			var elmWrap = document.createElement( 'div'),
				elmImg,
				loaded = false,
				retryTimer = null;
			elmWrap.className = CLASS_NAME_LOADING;
			pettanr.util.loadImage( url, onLoad, onError, 100, 10000);
			function onLoad( _url, _actualW, _actualH){
				if( elmWrap === null) return;
				elmImg = new Image;
				/*
				 * createElement 直後に append しないと、ie(ActiveX)で img が正しく表示されない．
				 */
				elmWrap.appendChild( elmImg);
				elmImg.setAttribute( 'src', url);
				elmWrap.className = CLASS_NAME;
				onLoadCallback && onLoadCallback( _url, _actualW, _actualH);
				onLoadCallback = null;
				loaded = true;
				resize( w, h);
			}
			function onError( _url){
				if( elmWrap === null) return;
				elmWrap.className = CLASS_NAME_ERROR;
				retryTimer = setTimeout( function(){
					elmWrap.className = CLASS_NAME_LOADING;
					pettanr.util.loadImage( url, onLoad, onError, 100, 10000);
				}, RETRY_DELAY);
			}
			function resize( _w, _h){
				w = _w !== undefined ? _w : w;
				h = _h !== undefined ? _h : h;
				if( loaded === false) return;
				elmImg.className = w < 0 || h < 0 ? ( 'img-flip-' + ( w < 0 && h < 0 ? 'vh' : ( w < 0 ? 'h' : 'v'))) : '';
			}
			return {
				elm : elmWrap,
				resize: resize,
				destroy: function(){
					loaded === true && elmWrap.removeChild( elmImg);
					retryTimer !== null && clearTimeout( retryTimer);
					elmWrap = vmlImg = onLoadCallback = retryTimer = null;
					elmWrap = elmImg = onLoadCallback = null;
					delete this.destroy;
				}
			}
		}
		var activexImage = css3Image;
		var vmlImage = function( url, w, h, onLoadCallback){
			var elmWrap = document.createElement( 'div'),
				vmlImg,
				loaded = false,
				retryTimer = null;
			elmWrap.className = CLASS_NAME_LOADING;
			pettanr.util.loadImage( url, onLoad, onError, 100, 10000);
			function onLoad( _url, _actualW, _actualH){
				if( elmWrap === null) return;
				elmWrap.className = CLASS_NAME;
				vmlImg = document.createElement( 'v:image');
				vmlImg.src = url;
				loaded = true;
				resize( w, h);
				onLoadCallback && onLoadCallback( _url, _actualW, _actualH);
				onLoadCallback = null;
			}
			function onError( _url){
				if( elmWrap === null) return;
				elmWrap.className = CLASS_NAME_ERROR;
				retryTimer = setTimeout( function(){
					elmWrap.className = CLASS_NAME_LOADING;
					pettanr.util.loadImage( url, onLoad, onError, 100, 10000);
				}, RETRY_DELAY);
			}
			function resize( _w, _h){
				w = _w !== undefined ? _w : w;
				h = _h !== undefined ? _h : h;
				if( loaded !== true) return;
				vmlImg.style.width = w < 0 ? -w : w +'px';
				vmlImg.style.height = h < 0 ? -h : h +'px';
				//if( flipH !== _flipH || flipV !== _flipV){
					vmlImg.parentNode === elmWrap && elmWrap.removeChild( vmlImg);
				//}
					vmlImg.className = w < 0 || h < 0 ? ( 'img-flip-' + ( w < 0 && h < 0 ? 'vh' : ( w < 0 ? 'h' : 'v'))) : '';
					elmWrap.appendChild( vmlImg);
			}
			return {
				elm : elmWrap,
				resize: resize,
				destroy: function(){
					loaded === true && elmWrap.removeChild( vmlImg);
					retryTimer !== null && clearTimeout( retryTimer);
					elmWrap = vmlImg = onLoadCallback = retryTimer = null;
					delete this.destroy;
				}
			}
		}
		var serverImage = function( url, w, h, onLoadCallback){
			
		}
		
		return function( url, w, h, onLoadCallback){
				var flipH = w < 0,
					flipV = h < 0,
					onLoadCallbackAsync = onLoadCallback,// ? function(){ setTimeout( onLoadCallback, 0);} : undefined,// 一度読み込んだ画像は即座にonLoadになるため遅延
					xBackendImage = ( function( urlIsXDomain){
						if( BACKEND === IS_CSS3) return css3Image.apply( {}, [ url, w, h, onLoadCallbackAsync]);
						if( BACKEND === IS_VML) return vmlImage.apply( {}, [ url, w, h, onLoadCallbackAsync]);
						if( BACKEND === IS_ACTIVEX) return activexImage.apply( {}, [ url, w, h, onLoadCallbackAsync]);
						return serverImage.apply( {}, [ url, w, h, onLoadCallbackAsync]);
					})();
				return {
					elm: xBackendImage.elm,
					w: function( _w){
						_w !== undefined && xBackendImage.resize( _w, h);
						return w;
					},
					h: function( _h){
						_h !== undefined && xBackendImage.resize( w, _h);
						return h;
					},
					resize: xBackendImage.resize,
					destroy: function(){
						xBackendImage.destroy && xBackendImage.destroy();
						xBackendImage = onLoadCallback = onLoadCallbackAsync = null;
						delete this.destroy;
					}
				}
			}
	})();
	return {
		createReversibleImage: function( url, w, h, onLoadCallback){
			return XBackendReversibleImageClass.apply( {}, [ url, w, h, onLoadCallback]);
		}
	}
})();

/*
 * bind : 製本
 */
pettanr.bind = ( function(){
	var BIND_WORKER_ARRAY = [],
		NAMESPACE_CLASSNAME = pettanr.CONST.NS_PETTANR_COMIC + '-',
		RESOURCE_PICTURE_PATH = pettanr.CONST.RESOURCE_PICTURE_PATH,
		ELM_DETECT_WIDTH = ( function(){
			var ret = document.createElement( 'div');
			ret.style.cssText = 'width: auto;height: 0;padding: 0;margin: 0;display: block;visibility: hidden;float: none;position: static;';
			return ret;
		})();

	/*
	 * original
	 *   http://d.hatena.ne.jp/uupaa/20090720/1248097177
	 */
	var ResizeAgentClass = function( onResizeFunction, opt_elmCheck){
		var	_globalLock = 0,
			_size = { w: 0, h: 0 };
			_ie = !!document.all,
			_quirks = (document.compatMode || "") !== "CSS1Compat",
			_ieroot = _quirks ? "body" : "documentElement";
			_root = opt_elmCheck ? opt_elmCheck : ( _ie ? document[_ieroot] : window);

		function getInnerSize() {
			return {
				w: _root.innerWidth  || _root.clientWidth,
				h: _root.innerHeight || _root.clientHeight
			};
		}

		function loop() {
			if (!_globalLock++) {
				var size = getInnerSize();
				if (_size.w !== size.w || _size.h !== size.h) { // resized
					_size = size; // update
					onResizeFunction( _size);
				}
				setTimeout( unlock, 0); // delay unlock
			}
			setTimeout(loop, 500);
		}
		function unlock(){
			_globalLock = 0;
		}
		loop();
	}
	
	
	var ElementBuilder = ( function(){
		var ELM_TITLE_ORIGN = ( function(){
				
			})(),
			ELM_TEXT_ORIGN = ( function(){
				var _table = document.createElement( 'table'),
					_tr = document.createElement( 'tr');
				_table.appendChild( _tr);
				_tr.appendChild( document.createElement( 'td'));
				_table.cellspacing = '0';
				return _table;
			})();
		
		function buildComicElement(){
			
		}
		
		function buildPanelElement( elmTarget, json, noClassnameMode){
			var _elmPanel = document.createElement( 'div'),
				_style = {
						"border-width":		typeof json.border === 'number' ? json.border + 'px' : 0,
						width: 				json.width + 'px',
						height:				json.height + 'px'
				},
				_cssText = [],
				_comicElements = json.panel_elements || [],
				_comicElement, _elmImgWrap, _rImg, _rPic, _balloon, _elmBalloonWrap, _elmText;
			if( noClassnameMode === true){
				
			} else {
				_elmPanel.className = NAMESPACE_CLASSNAME + 'panel';
			}
			for( var _key in _style){
				_cssText.push( _key + ':' + _style[ _key]);
			}
			_elmPanel.style.cssText = _cssText.join( ';');
			elmTarget.appendChild( _elmPanel);
			
			for( var i=0, l=_comicElements.length; i<l; ++i){
				_comicElement = _comicElements[ i];
				if( _comicElement.resource_picture){
					_rPic = _comicElement.resource_picture || {};
					_rImg = pettanr.image.createReversibleImage(
							[ RESOURCE_PICTURE_PATH, _rPic.id, '.', _rPic.ext].join( ''),
							_comicElement.width, _comicElement.height
						);
					_elmImgWrap = document.createElement( 'div');
					_elmPanel.appendChild( _elmImgWrap);
					_elmImgWrap.appendChild( _rImg.elm);
					_elmImgWrap.className = NAMESPACE_CLASSNAME + 'image';
					_elmImgWrap.style.cssText = [
						'width:', Math.abs( _comicElement.width), 'px;',
						'height:', Math.abs( _comicElement.height), 'px;',
						'left:', _comicElement.x, 'px;',
						'top:', _comicElement.y, 'px;',
						'z-index:', _comicElement.z, ';'
					].join( '');
				} else {
					_elmBalloonWrap = document.createElement( 'div');
					_elmPanel.appendChild( _elmBalloonWrap);
					_elmBalloonWrap.className = NAMESPACE_CLASSNAME + 'balloon';
					_elmBalloonWrap.style.cssText = [
						'width:', _comicElement.width, 'px;',
						'height:', _comicElement.height, 'px;',
						'left:', _comicElement.x, 'px;',
						'top:', _comicElement.y, 'px;',
						'z-index:', _comicElement.z, ';'
					].join( '');

					_balloon = pettanr.balloon.createBalloon( _comicElement.width, _comicElement.height, _comicElement.tail);
					_elmBalloonWrap.appendChild( _balloon.elm);
					
					_elmText = ELM_TEXT_ORIGN.cloneNode( true);
					_elmBalloonWrap.appendChild( _elmText);
					_elmText.className = NAMESPACE_CLASSNAME + 'speach';
					_elmText.getElementsByTagName( 'td')[ 0].appendChild( document.createTextNode( 'hello'));
				}
			}
		}
		
		return {
			build: function( elmTarget, json, zoom, noClassnameMode){
				// clean elmTarget
				pettanr.util.removeAllChildren( elmTarget);
				
				// json is Comic ? Panel ?
				if( json.panels){
					// comic
					
				} else
				if( json.panel_elements){
					// panel
					buildPanelElement( elmTarget, json, noClassnameMode);
				} else {
					// invalid json
				}
			}
		}
	})();
	
	var BindWorkerClass = function( elmTarget, json, zoomSelfEnabled, noClassnameMode){
		typeof json === 'object' && build( elmTarget, json);
		
		var elmDetectW = ELM_DETECT_WIDTH.cloneNode( false)
		
		if( zoomSelfEnabled === true){
			elmTarget.parentNode.insertBefore( elmDetectW, elmTarget);
			new ResizeAgentClass( onResize, elmDetectW);
		}
		function onResize(){
			
		}
		json && ElementBuilder.build( elmTarget, json, zoomSelfEnabled, noClassnameMode);
		
		return {
			init: function(){
				
			},
			zoom: function(){
				
			},
			json: function( _json){
				json = _json;
				ElementBuilder.build( elmTarget, _json, zoomSelfEnabled, noClassnameMode);
			},
			targetElement: function(){
				
			},
			layput: function(){
				
			},
			destroy: function(){
				
			}
		}
	}
	
	return {
		createBindWorker: function( elmTarget, opt_COMICJSONorPANELJSON, opt_zoomSelfEnabled, opt_noClassnameMode){
			var ret = new BindWorkerClass( elmTarget, opt_COMICJSONorPANELJSON, !!opt_zoomSelfEnabled, !!opt_noClassnameMode);
			BIND_WORKER_ARRAY.push( ret);
			return ret;
		},
		isBindWorkerInstance: function( _bindWorker){
			
		}
	}
})();

var VisualEffect = ( function(){
	
	var ANIMATION_TICKET_ARRAY = [],
		fpms = 50,
		TIMER = null,
		FILTER = 'filter',
		OPACITY = 'opacity',
		REG_ALPHA = /alpha\([^)]*\)/i,
		CORON = ':',
		EMPTY = '',
		SEMICORON = ';';
	
	function startAnimation( _elm, _cssObject, _onComplete, _onEnterFrame, _numFrames){
		var _ticket;
		for( var i=0, l=ANIMATION_TICKET_ARRAY.length; i<l; ++i){
			_ticket = ANIMATION_TICKET_ARRAY[ i];
			if( _ticket.elm === _elm) {
				_ticket.destroy();
				break;
			}
		}
		//  coputedStyle と _cssObject を比較して , 一致及び非数は削除しつつ コピー
		//  filter opacity の追加 REG_ALPHA.test( _value ) ? _value.replace( REG_ALPHA, opacity ) : _value + " " + opacity
		/*
		 * cssObject をまわす
		 * 非数は削除
		 * cssText と一致も削除
		 * coputedStyle と一致も削除
		 * updateTraget ととして記録
		 * 初期値を cssObject としてセット
		 * cssTest にセット zoom もセット　
		 */
		
		//
		/*
			var style = elem.style,
				currentStyle = elem.currentStyle,
				opacity = jQuery.isNumeric( value ) ? "alpha(opacity=" + value * 100 + ")" : "",
				filter = currentStyle && currentStyle.filter || style.filter || "";

			// IE has trouble with opacity if it does not have layout
			// Force it by setting the zoom level
			style.zoom = 1;
		 */
		
		var _currentParameters = [],
			_offsetParameters = [],
			_endParameters = [],
			_targetAttributes = [];
		
		ANIMATION_TICKET_ARRAY.push( new AnimationTaskClass(
			_elm,
			_currentParameters, _offsetParameters, _endParameters, _targetAttributes,
			typeof _onComplete === 'function' ? _onComplete : null,
			typeof _onEnterFrame === 'function' ? _onEnterFrame : null,
			_numFrames
		));
		
		if( TIMER === null){
			TIMER = window.setInterval( onEnterFrame, fpms);
		}
	}
	function onEnterFrame(){
		var _ticket,
			i = 0;
		while( i<ANIMATION_TICKET_ARRAY.length){
			_ticket = ANIMATION_TICKET_ARRAY[ i];
			if( _ticket.onEnterFrame() === true){
				_ticket.destroy();
				ANIMATION_TICKET_ARRAY.splice( i, 1);
			} else {
				++i;
			}
		}
		if( ANIMATION_TICKET_ARRAY.length === 0){
			window.clearInterval( TIMER);
			TIMER = null;
		}
	}
	function updateCss( _elm, _updateParameters, _targetAttributes, _numAttributes){
		if( _numAttributes > 1){
			var _cssTexts = _elm.style.cssText.split( ';'), _css,
				_separate,
				_cssObject = {}, _target, _value, _number, _px,
				j;
			for(var i=0, l=_cssTexts.length; i<l; ++i){
				_css = _cssTexts[ i];
				_separate = _css.indexOf( ':');
				if( _separate >= 3){
					_target = _css.substr( 0, _separate +1);
					_value = _css.substr( _separate +1);
					/*
					 * ie filter
					 */
					if( _target === FILTER){
						for( j=0; j<_numAttributes; ++j){
							if( _targetAttributes[ j] === OPACITY){
								_cssTexts[ i] = [
										_target, ':',
										_value.replace( REG_ALPHA, "alpha(opacity=" + _updateParameters[ j] * 100 + ")")
									].join( '');
								break;
							}
						}
					/*
					 * other
					 */
					} else {
						_number = '' + parseFloat( _value);
						_px = _value.indexOf( _number);
						_px = _px > 0 ? _value.substr( _px + _number.length) : '';
						for( j=0; j<_numAttributes; ++j){
							if( _targetAttributes[ j] === _target){
								_cssTexts[ i] = [ _target, ':', _updateParameters[ j], _px].join( '');
								break;
							}
						}						
					}
				}
			}
			_elm.style.cssText = _cssTexts.join( ';');
			return;	
		}
		/*
		 * 一度に update する Attributes が少ない場合、cssText は使用しない.
		 */
	}
	
	var AnimationTaskClass = function( ELM, currentParameters, offsetParameters, endParameters, targetAttributes, onComplete, onEnterFrame, numFrames){
		var l = targetAttributes.length;
		return {
			elm:	ELM,
			onEnterFrame: function(){
				var _updateCss = {};
				if( numFrames === 1){
					for( var i=0; i<l; ++i){
						_updateCss[ targetAttributes[ i]] = endParameters[ i];
						++i;
					}
					updateCss( ELM, currentParameters, targetAttributes, l);
					onComplete !== null && onComplete();
				} else {
					for( var i=0; i<l; ++i){
						_updateCss[ targetAttributes[ i]] = currentParameters[ i] = Math.floor( currentParameters[ i] + offsetParameters[ i]);
						++i;
					}
					updateCss( ELM, currentParameters, targetAttributes, l);
					onEnterFrame !== null && onEnterFrame( _updateCss);
				}
				--numFrames;
				return numFrames === 0;
			},
			destroy: function(){
				ELM = onComplete = onEnterFrame = null;
			}
		}
	}
	
	var VisualEffectClass = function( ELM){
		var isHtmlElement;
		
		function resisterAnime( _cssObject, _onComplete, _onEnterFrame, _time){
			var _numFrames = Math.floor( _time / fpms);
			startAnimation( ELM, _cssObject, _onComplete, _onEnterFrame, _numFrames);
		}
		function startFadeIn(){
			
		}
		function startFadeOut(){
			
		}
		function update( _x, _y, _w, _h){
			var _cssText = ELM.style.cssText;
			
		}
		
		this.anime = resisterAnime;
		this.fadeIn = startFadeIn;
		this.fadeOut = startFadeOut;
		this.update = update;
	}
	
	return {
		createVisualEffect: function( _elm){
			return new VisualEffectClass( _elm);
		},
		isInstanceOfVisualEffect: function( _instance){
			return _instance instanceof VisualEffectClass;
		}
	}
})();



/*
 *  Google Analytics
 */

if( pettanr.LOCAL === false){
	var _gaq = _gaq || [];
	_gaq.push(['_setAccount', 'UA-28023955-1']);
	_gaq.push(['_trackPageview']);
	
	(function() {
		var ga = document.createElement('script'); ga.type = 'text/javascript'; ga.async = true;
		ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
		var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(ga, s);
	})();	
}