require 'spec_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

describe PanelsController do

  # This should return the minimal set of attributes required to create a valid
  # Panel. As you add validations to Panel, be sure to
  # update the return value of this method accordingly.
  def valid_attributes
    {}
  end

  describe "GET index" do
    it "assigns all panels as @panels" do
      panel = Panel.create! valid_attributes
      get :index
      assigns(:panels).should eq([panel])
    end
  end

  describe "GET show" do
    it "assigns the requested panel as @panel" do
      panel = Panel.create! valid_attributes
      get :show, :id => panel.id
      assigns(:panel).should eq(panel)
    end
  end

  describe "GET new" do
    it "assigns a new panel as @panel" do
      get :new
      assigns(:panel).should be_a_new(Panel)
    end
  end

  describe "GET edit" do
    it "assigns the requested panel as @panel" do
      panel = Panel.create! valid_attributes
      get :edit, :id => panel.id
      assigns(:panel).should eq(panel)
    end
  end

  describe "POST create" do
    describe "with valid params" do
      it "creates a new Panel" do
        expect {
          post :create, :panel => valid_attributes
        }.to change(Panel, :count).by(1)
      end

      it "assigns a newly created panel as @panel" do
        post :create, :panel => valid_attributes
        assigns(:panel).should be_a(Panel)
        assigns(:panel).should be_persisted
      end

      it "redirects to the created panel" do
        post :create, :panel => valid_attributes
        response.should redirect_to(Panel.last)
      end
    end

    describe "with invalid params" do
      it "assigns a newly created but unsaved panel as @panel" do
        # Trigger the behavior that occurs when invalid params are submitted
        Panel.any_instance.stub(:save).and_return(false)
        post :create, :panel => {}
        assigns(:panel).should be_a_new(Panel)
      end

      it "re-renders the 'new' template" do
        # Trigger the behavior that occurs when invalid params are submitted
        Panel.any_instance.stub(:save).and_return(false)
        post :create, :panel => {}
        response.should render_template("new")
      end
    end
  end

  describe "PUT update" do
    describe "with valid params" do
      it "updates the requested panel" do
        panel = Panel.create! valid_attributes
        # Assuming there are no other panels in the database, this
        # specifies that the Panel created on the previous line
        # receives the :update_attributes message with whatever params are
        # submitted in the request.
        Panel.any_instance.should_receive(:update_attributes).with({'these' => 'params'})
        put :update, :id => panel.id, :panel => {'these' => 'params'}
      end

      it "assigns the requested panel as @panel" do
        panel = Panel.create! valid_attributes
        put :update, :id => panel.id, :panel => valid_attributes
        assigns(:panel).should eq(panel)
      end

      it "redirects to the panel" do
        panel = Panel.create! valid_attributes
        put :update, :id => panel.id, :panel => valid_attributes
        response.should redirect_to(panel)
      end
    end

    describe "with invalid params" do
      it "assigns the panel as @panel" do
        panel = Panel.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        Panel.any_instance.stub(:save).and_return(false)
        put :update, :id => panel.id, :panel => {}
        assigns(:panel).should eq(panel)
      end

      it "re-renders the 'edit' template" do
        panel = Panel.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        Panel.any_instance.stub(:save).and_return(false)
        put :update, :id => panel.id, :panel => {}
        response.should render_template("edit")
      end
    end
  end

  describe "DELETE destroy" do
    it "destroys the requested panel" do
      panel = Panel.create! valid_attributes
      expect {
        delete :destroy, :id => panel.id
      }.to change(Panel, :count).by(-1)
    end

    it "redirects to the panels list" do
      panel = Panel.create! valid_attributes
      delete :destroy, :id => panel.id
      response.should redirect_to(panels_url)
    end
  end

end
