require 'spec_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

describe SourcePicturesController do

  # This should return the minimal set of attributes required to create a valid
  # SourcePicture. As you add validations to SourcePicture, be sure to
  # update the return value of this method accordingly.
  def valid_attributes
    {}
  end

  describe "GET index" do
    it "assigns all source_pictures as @source_pictures" do
      source_picture = SourcePicture.create! valid_attributes
      get :index
      assigns(:source_pictures).should eq([source_picture])
    end
  end

  describe "GET show" do
    it "assigns the requested source_picture as @source_picture" do
      source_picture = SourcePicture.create! valid_attributes
      get :show, :id => source_picture.id
      assigns(:source_picture).should eq(source_picture)
    end
  end

  describe "GET new" do
    it "assigns a new source_picture as @source_picture" do
      get :new
      assigns(:source_picture).should be_a_new(SourcePicture)
    end
  end

  describe "GET edit" do
    it "assigns the requested source_picture as @source_picture" do
      source_picture = SourcePicture.create! valid_attributes
      get :edit, :id => source_picture.id
      assigns(:source_picture).should eq(source_picture)
    end
  end

  describe "POST create" do
    describe "with valid params" do
      it "creates a new SourcePicture" do
        expect {
          post :create, :source_picture => valid_attributes
        }.to change(SourcePicture, :count).by(1)
      end

      it "assigns a newly created source_picture as @source_picture" do
        post :create, :source_picture => valid_attributes
        assigns(:source_picture).should be_a(SourcePicture)
        assigns(:source_picture).should be_persisted
      end

      it "redirects to the created source_picture" do
        post :create, :source_picture => valid_attributes
        response.should redirect_to(SourcePicture.last)
      end
    end

    describe "with invalid params" do
      it "assigns a newly created but unsaved source_picture as @source_picture" do
        # Trigger the behavior that occurs when invalid params are submitted
        SourcePicture.any_instance.stub(:save).and_return(false)
        post :create, :source_picture => {}
        assigns(:source_picture).should be_a_new(SourcePicture)
      end

      it "re-renders the 'new' template" do
        # Trigger the behavior that occurs when invalid params are submitted
        SourcePicture.any_instance.stub(:save).and_return(false)
        post :create, :source_picture => {}
        response.should render_template("new")
      end
    end
  end

  describe "PUT update" do
    describe "with valid params" do
      it "updates the requested source_picture" do
        source_picture = SourcePicture.create! valid_attributes
        # Assuming there are no other source_pictures in the database, this
        # specifies that the SourcePicture created on the previous line
        # receives the :update_attributes message with whatever params are
        # submitted in the request.
        SourcePicture.any_instance.should_receive(:update_attributes).with({'these' => 'params'})
        put :update, :id => source_picture.id, :source_picture => {'these' => 'params'}
      end

      it "assigns the requested source_picture as @source_picture" do
        source_picture = SourcePicture.create! valid_attributes
        put :update, :id => source_picture.id, :source_picture => valid_attributes
        assigns(:source_picture).should eq(source_picture)
      end

      it "redirects to the source_picture" do
        source_picture = SourcePicture.create! valid_attributes
        put :update, :id => source_picture.id, :source_picture => valid_attributes
        response.should redirect_to(source_picture)
      end
    end

    describe "with invalid params" do
      it "assigns the source_picture as @source_picture" do
        source_picture = SourcePicture.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        SourcePicture.any_instance.stub(:save).and_return(false)
        put :update, :id => source_picture.id, :source_picture => {}
        assigns(:source_picture).should eq(source_picture)
      end

      it "re-renders the 'edit' template" do
        source_picture = SourcePicture.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        SourcePicture.any_instance.stub(:save).and_return(false)
        put :update, :id => source_picture.id, :source_picture => {}
        response.should render_template("edit")
      end
    end
  end

  describe "DELETE destroy" do
    it "destroys the requested source_picture" do
      source_picture = SourcePicture.create! valid_attributes
      expect {
        delete :destroy, :id => source_picture.id
      }.to change(SourcePicture, :count).by(-1)
    end

    it "redirects to the source_pictures list" do
      source_picture = SourcePicture.create! valid_attributes
      delete :destroy, :id => source_picture.id
      response.should redirect_to(source_pictures_url)
    end
  end

end
